'use strict';const PropTypes=require('prop-types'),React=require('react'),ButtonDropdown=require('../../button-dropdown/button-dropdown'),CreateModelButton=require('../../create-model-button/create-model-button'),DateDisplay=require('../../date-display/date-display'),Popup=require('../../popup/popup');class ProfileModelList extends React.Component{constructor(){super(),this.state={loadingModels:!1,models:null,notification:null}}componentWillMount(){this._fetchModels(this.props.facadesExist)}componentWillReceiveProps(a){const b=this.props;(b.userInfo.profile!==a.userInfo.profile||b.facadesExist!==a.facadesExist)&&this._fetchModels(a.facadesExist)}_fetchModels(a){return a?void this.setState({loadingModels:!0},()=>{this.props.listModelsWithInfo(this._fetchModelsCallback.bind(this))}):void console.warn('Controller not connected, skipping fetching models.')}_fetchModelsCallback(a,b){this.setState({loadingModels:!1},()=>{if(a){const b='Cannot load models';return console.error(b,a),void this.props.addNotification({title:b,message:`${b}: ${a}`,level:'error'})}const c={owned:[],shared:[]};b.forEach((a)=>{`${this.props.userInfo.profile}@external`===a.owner?c.owned.push(a):c.shared.push(a)}),this.setState({models:c})})}_showConfirmation(a){const b=`Are you sure you want to destroy ${a.name}?`+' All the applications and units included in the model will be destroyed. This action cannot be undone.';this.setState({notification:React.createElement(Popup,{buttons:[{title:'Cancel',action:()=>this.setState({notification:null}),type:'inline-neutral'},{title:'Destroy',action:()=>{this.setState({notification:null}),this.props.destroyModels([a.uuid],()=>{this._fetchModels(this.props.facadesExist)})},type:'destructive'}],title:'Destroy model'},React.createElement('p',null,b))})}_destroyModel(a,b,c){return c.preventDefault(),c.stopPropagation(),this.refs[b]._toggleDropdown(),a.isController?void this.props.addNotification({title:'Cannot destroy model',message:'The controller model cannot be destroyed.',level:'error'}):void this._showConfirmation(a)}_generateMyModels(){const a='My models',b=this._generateTableHeader(['Name','Machines, Cloud/region','Last accessed','Action'],'mymodels'),c=this.state.models,d=c&&c.owned;if(!d||0===d.length)return[this._generateHeader(a,0,!0),b];const e=d.reduce((a,b,c)=>{if(b.isAlive){const d=`mymodel-button-dropdown-${c}`;return a.push({id:b.id,name:b.name,provider:`${b.numMachines} ${b.provider.toUpperCase()}/${b.region.toUpperCase()}`,lastConnection:b.lastConnection,action:React.createElement(ButtonDropdown,{ref:d,listItems:[React.createElement('li',{className:'dropdown-menu__list-item',role:'menuitem',tabIndex:'0',key:'delete'},React.createElement('a',{className:'dropdown-menu__list-item-link',onClick:this._destroyModel.bind(this,b,d)},'Delete'))],tooltip:'more',icon:'contextual-menu-16'})}),a}},[]);if(!e||!e.length)return null;const f=this._generateRows(e,['name','provider','lastConnection','action']);return React.createElement('ul',{className:'profile-model-list__list'},[this._generateHeader(a,e.length,!0),b,...f])}_generateSharedModels(){const a='Models shared with me',b=this._generateTableHeader(['Name','Machines, Cloud/region','Permissions','Owner'],'sharedmodels'),c=this.state.models,d=c&&c.shared;if(!d||0===d.length)return[this._generateHeader(a,0),b];const e=d.reduce((a,b)=>{if(b.isAlive){const c=b.users?b.users.filter((a)=>a.displayName===this.props.userInfo.profile):null;return a.push({id:b.id,name:b.name,provider:`${b.numMachines} ${b.provider.toUpperCase()}/${b.region.toUpperCase()}`,access:c.length&&c[0].access,owner:b.owner.replace('@external','')}),a}},[]),f=this._generateRows(e,['name','provider','access','owner']);return React.createElement('ul',{className:'profile-model-list__list'},[this._generateHeader(a,e.length),b,...f])}_generateHeader(a,b,c=!1){const d=this.props;return React.createElement('li',{className:'profile-model-list__header',key:a},React.createElement('span',{className:'profile-model-list__header-title'},`${a} (${b})`),c?React.createElement(CreateModelButton,{title:'Start a new model',changeState:d.changeState,switchModel:d.switchModel}):null)}_generateTableHeader(a,b){return React.createElement('li',{className:'profile-model-list__table-header',key:b},a.map((a)=>React.createElement('span',{key:a},a)))}switchToModel(a,b){b.preventDefault(),b.stopPropagation(),this.props.switchModel(a)}_generateRows(a,b){function c(a,b){switch(b){case'lastConnection':return React.createElement(DateDisplay,{date:a[b]||'--',relative:!0});break;case'name':const c=a.owner||this.props.userInfo.profile,d=a.name,e=`${this.props.baseURL}u/${c}/${d}`;return React.createElement('a',{href:e,onClick:this.switchToModel.bind(this,{name:d,id:a.id,owner:c})},a.name);break;default:return a[b];}}return a.map((a,d)=>React.createElement('li',{className:'profile-model-list__row',key:d},b.map((b)=>React.createElement('span',{key:`${b}-${d}`},c.call(this,a,b)))))}_generateNotification(){return this.state.notification?this.state.notification:void 0}render(){return React.createElement('div',{className:'profile-model-list'},this._generateMyModels(),this._generateSharedModels(),this._generateNotification())}}ProfileModelList.propTypes={acl:PropTypes.object,addNotification:PropTypes.func.isRequired,baseURL:PropTypes.string.isRequired,changeState:PropTypes.func.isRequired,destroyModels:PropTypes.func.isRequired,facadesExist:PropTypes.bool.isRequired,listModelsWithInfo:PropTypes.func.isRequired,models:PropTypes.array,switchModel:PropTypes.func.isRequired,userInfo:PropTypes.object.isRequired},module.exports=ProfileModelList;