'use strict';const endpointUtils=require('./endpoint-utils'),utils=require('../../test/utils'),EndpointsController=require('./endpoints-controller'),createApp=(a,b={})=>{const c=Object.assign({apiAddress:'http://api.example.com/',controllerSocketTemplate:'wss://$server:$port/api',socket_protocol:'wss',baseUrl:'http://example.com/',charmstoreURL:'http://1.2.3.4/',flags:{},gisf:!1,plansURL:'http://plans.example.com/',termsURL:'http://terms.example.com/'},b);return new a(c)};describe('Relation endpoints logic',()=>{function a(a){var b=[];!1===a?f.forEach(function(a){'relationInfo'!==a[0]&&b.push(a)}):b=f,c.onDelta({detail:{data:{result:b}}})}let b,c,d,e,f,g;beforeAll((a)=>{YUI(GlobalConfig).use(MODULES,(b)=>{f=utils.loadFixture('data/large_stream.json',!0),e=utils.loadFixture('data/large_endpoints.json',!0),window.yui=b,window.GUI_VERSION={version:'1.2.3'},g=require('../init'),a()})}),beforeEach(function(){const a=new window.jujugui.User({sessionStorage:function(){return new function(){return{store:{},setItem:function(a,b){this.store.name=b},getItem:function(){return this.store.name||null}}}}()});a.controller={user:'user',password:'password'},b=utils.makeAppContainer(),d=createApp(g),c=d.db}),afterEach(function(){d.destructor(),b.remove()}),it('should be able to find relatable services',function(){a(!1),d.endpointsController.endpointsMap=e;var b=c.services.getById('mediawiki'),f=Object.keys(endpointUtils.getEndpoints(b,d.endpointsController));f.sort(),f.should.eql(['memcached','mysql','puppet','rsyslog-forwarder-ha'])}),it('should find valid targets including subordinates',function(){a(!1),d.endpointsController.endpointsMap=e;var b,f=c.services.getById('memcached'),g=endpointUtils.getEndpoints(f,d.endpointsController);b=Object.keys(g),b.sort(),b.should.eql(['mediawiki','puppet','rsyslog-forwarder-ha','wordpress'])}),it('should find multi-series subordinates with matching series',function(){a(!1),d.endpointsController.endpointsMap=e,d.db.services.getById('mediawiki').set('series','trusty');const b=d.db.services.getById('puppet');b.set('series','xenial'),b.set('subordinate',!0),b.set('pending',!0);const f=d.db.charms.add({id:b.get('charm'),is_subordinate:!0});f.set('series',['xenial','trusty']),d.db.services.getById('rsyslog-forwarder-ha').set('series','precise');let g=c.services.getById('memcached');g.set('series','trusty');const h=endpointUtils.getEndpoints(g,d.endpointsController),i=Object.keys(h);i.sort(),i.should.eql(['mediawiki','puppet','rsyslog-forwarder-ha','wordpress'])}),it('should match app series if it is a multi-series subordinate',function(){a(!1),d.endpointsController.endpointsMap=e,d.db.services.getById('mediawiki').set('series','trusty'),d.db.services.getById('wordpress').set('series','trusty'),d.db.services.getById('rsyslog-forwarder-ha').set('series','precise');let b=c.services.getById('memcached');b.set('series','xenial'),b.set('subordinate',!0),b.set('pending',!0);const f=d.db.charms.add({id:b.get('charm'),is_subordinate:!0});f.set('series',['xenial','trusty']);const g=endpointUtils.getEndpoints(b,d.endpointsController),h=Object.keys(g);h.sort(),h.should.eql(['mediawiki','wordpress'])}),it('should find ambigious targets',function(){a(),d.endpointsController.endpointsMap=e;var b=c.services.getById('mysql'),f=endpointUtils.getEndpoints(b,d.endpointsController),g=Object.keys(f);g.sort(),g.should.eql(['mediawiki']),f.mediawiki.should.eql([[{name:'db',service:'mysql',type:'mysql'},{name:'slave',service:'mediawiki',type:'mysql'}],[{name:'db',service:'mysql',type:'mysql'},{name:'db',service:'mediawiki',type:'mysql'}]]),f=endpointUtils.getEndpoints(c.services.getById('mediawiki'),d.endpointsController),f.mysql.should.eql([[{name:'slave',service:'mediawiki',type:'mysql'},{name:'db',service:'mysql',type:'mysql'}],[{name:'db',service:'mediawiki',type:'mysql'},{name:'db',service:'mysql',type:'mysql'}]])}),it('should find valid targets for a requires',function(){a(),d.endpointsController.endpointsMap=e;var b=c.services.getById('wordpress'),f=endpointUtils.getEndpoints(b,d.endpointsController),g=Object.keys(f);g.sort(),g.should.eql(['memcached','rsyslog-forwarder-ha'])}),it('should find valid targets for subordinates',function(){a(!1),d.endpointsController.endpointsMap=e;var b=c.services.getById('puppet'),f=endpointUtils.getEndpoints(b,d.endpointsController),g=Object.keys(f);g.sort(),g.should.eql(['mediawiki','memcached','mysql','puppetmaster','rsyslog','rsyslog-forwarder-ha','wordpress']),b=c.services.getById('rsyslog-forwarder-ha'),f=endpointUtils.getEndpoints(b,d.endpointsController),g=Object.keys(f),g.sort(),g.should.eql(['mediawiki','memcached','mysql','puppet','puppetmaster','rsyslog','wordpress'])})}),describe('Endpoints map',function(){var a,b,c;beforeAll(function(b){YUI(GlobalConfig).use(['juju-models'],function(c){a=c.namespace('juju.models'),b()})}),beforeEach(function(){b=new EndpointsController,c=new a.Charm({id:'cs:precise/wordpress-2'})}),afterEach(function(){b.destructor(),c.destroy()}),it('should add a service to the map',function(){b.endpointsMap={},c.set('relations',{provides:{url:{interface:'http',optional:'false'},"logging-dir":{interface:'logging',scope:'container'}},requires:{db:{interface:'mysql',optional:'false'},cache:{interface:'varnish',optional:'true'}}}),b.addServiceToEndpointsMap('wordpress',c),b.endpointsMap.should.eql({wordpress:{provides:[{name:'url',interface:'http',optional:'false'},{name:'logging-dir',interface:'logging',scope:'container'}],requires:[{name:'db',interface:'mysql',optional:'false'},{name:'cache',interface:'varnish',optional:'true'}]}})}),it('should add a service to the map, requires only',function(){b.endpointsMap={},c.set('relations',{requires:{db:{interface:'mysql',optional:'false'},cache:{interface:'varnish',optional:'true'}}}),b.addServiceToEndpointsMap('wordpress',c),b.endpointsMap.should.eql({wordpress:{provides:[],requires:[{name:'db',interface:'mysql',optional:'false'},{name:'cache',interface:'varnish',optional:'true'}]}})}),it('should add a service to the map, provides only',function(){b.endpointsMap={},c.set('relations',{provides:{url:{interface:'http',optional:'false'},"logging-dir":{interface:'logging',scope:'container'}}}),b.addServiceToEndpointsMap('wordpress',c),b.endpointsMap.should.eql({wordpress:{requires:[],provides:[{name:'url',interface:'http',optional:'false'},{name:'logging-dir',interface:'logging',scope:'container'}]}})}),it('should add a service to the map, neither provides nor requires',function(){b.endpointsMap={},b.addServiceToEndpointsMap('wordpress',c),b.endpointsMap.should.eql({wordpress:{requires:[],provides:[]}})}),it('should reset the map',function(){var a={columbus:'sailed the ocean blue'};b.endpointsMap=a,b.endpointsMap.should.eql(a),b.reset(),b.endpointsMap.should.eql({})})}),describe('Endpoints map handlers',function(){let a,b,c,d,e,f;beforeAll((a)=>{YUI(GlobalConfig).use(MODULES.concat(['juju-tests-factory','datasource-local']),(b)=>{e=b.namespace('juju-tests.factory'),window.yui=b,window.GUI_VERSION={version:'1.2.3'},f=require('../init'),a()})}),beforeEach(()=>{d=[],b=utils.makeAppContainer(),a=createApp(f),c=a.endpointsController,c.endpointsMap={}}),afterEach(function(){a.destructor(),b.remove(),d.forEach((a)=>a.destroy()),d=null}),it('should update endpoints map when pending services are added',function(b){var f='cs:precise/wordpress-2';a.db.charms.add({id:f});var g=a.db.charms.getById(f);d.push(g),g.loaded=!0;const h=()=>{c.endpointsMap.should.eql({wordpress:{requires:[],provides:[]}}),document.removeEventListener('endpointMapAdded',h),b()};document.addEventListener('endpointMapAdded',h),a.db.services.add({id:'wordpress',pending:!0,loaded:!0,charmstore:e.makeFakeCharmstore(),charm:f})}),it('should update endpoints map when non-pending services are added',function(b){var f='cs:precise/wordpress-2';a.db.charms.add({id:f});var g=a.db.charms.getById(f);d.push(g),g.loaded=!0;const h=()=>{c.endpointsMap.should.eql({wordpress:{requires:[],provides:[]}}),document.removeEventListener('endpointMapAdded',h),b()};document.addEventListener('endpointMapAdded',h),a.db.services.add({id:'wordpress',pending:!1,loaded:!0,charmstore:e.makeFakeCharmstore(),charm:f})}),it('updates subordinate value when non-pending services are added',function(b){var c='puppet',e='cs:precise/puppet-2';a.db.charms.add({id:e,is_subordinate:!0});var f=a.db.charms.getById(e);d.push(f),f.loaded=!0;const g=()=>{var e=a.db.services.getById(c);assert.isTrue(e.get('subordinate')),d.push(e),document.removeEventListener('endpointMapAdded',g),b()};document.addEventListener('endpointMapAdded',g),a.db.services.add({id:c,pending:!1,loaded:!0,charm:e})}),it('should remove service from endpoints map when it is deleted',function(){var b='wordpress',e='cs:precise/wordpress-2',f=a.db.charms.add({id:e});d.push(f),a.db.services.add({id:b,loaded:!0,charm:e}),c.endpointsMap={wordpress:'foo'};var g=a.db.services.getById(b);a.db.services.remove(g),c.endpointsMap.should.eql({})}),it('should reset the map when the services reset',function(){var b='cs:precise/wordpress-2',e=a.db.charms.add({id:b});d.push(e),a.db.services.add({id:'wordpress',loaded:!0,charm:b}),c.endpointsMap={wordpress:'foo'},a.db.services.reset(),c.endpointsMap.should.eql({})})}),describe('Application config handlers',()=>{let a,b,c,d,e;beforeAll((b)=>{YUI(GlobalConfig).use(MODULES.concat(['environment-change-set']),(c)=>{window.yui=c,window.GUI_VERSION={version:'1.2.3'},a=require('../init'),b()})}),beforeEach(()=>{e=[],d=utils.makeAppContainer(),b=createApp(a,{conn:new utils.SocketStub}),b.modelAPI.set('facades',{Application:[1],Charms:[2]}),b.modelAPI.connect(),c=b.modelAPI.get('conn')}),afterEach(()=>{b.destructor(),d.remove(),e.forEach((a)=>a.destroy()),e=null,c=null}),it('should not call Application.Get when a pending service is added',function(){b.db.services.add({id:'wordpress',pending:!0,charm:'cs:precise/wordpress-2'}),assert.equal(c.messages.length,1);const a=c.last_message();assert.equal(a.type,'Admin'),assert.equal(a.request,'Login')}),it('should call Application.Get when non-pending services are added',function(){var a='cs:precise/wordpress-2',d=b.db.charms.add({id:a});e.push(d),d.loaded=!0,b.db.services.add({id:'wordpress',pending:!1,charm:a}),assert.equal(c.messages.length,2);var f=c.last_message();assert.strictEqual(f.type,'Application'),assert.strictEqual(f.request,'Get')}),it('should call Application.Get when a charm changes',function(){var a='wordpress',d='cs:precise/wordpress-2',f=b.db.charms.add({id:d});e.push(f),f.loaded=!0,b.db.services.add({id:a,pending:!1,charm:d}),assert.equal(c.messages.length,2);var g=c.last_message();assert.strictEqual(g.type,'Application'),assert.strictEqual(g.request,'Get');var h=b.db.services.getById(a);d='cs:precise/wordpress-3';var i=b.db.charms.add({id:d,loaded:!0});e.push(i),h.set('charm',d),assert.equal(c.messages.length,2);var g=c.last_message();assert.strictEqual(g.type,'Application'),assert.strictEqual(g.request,'Get')})});