'use strict';var _this=this;const relationUtils=require('./relation-utils');describe('RelationUtils',()=>{let a;beforeAll((b)=>{YUI(GlobalConfig).use('juju-models',function(c){a=c.namespace('juju.models'),b()})}),describe('generateSafeDOMId',()=>{it('can generate a hash',()=>{assert.strictEqual(relationUtils.generateHash(''),0),assert.isNumber(relationUtils.generateHash('kumquat')),assert.isNumber(relationUtils.generateHash('qumquat')),assert.strictEqual(relationUtils.generateHash('kumquat'),relationUtils.generateHash('kumquat')),assert.notEqual(relationUtils.generateHash('kumquat'),relationUtils.generateHash('qumquat'))}),it('can generate safe relation ids',()=>{const a='foo:Bar relation-00000006!@#';assert.strictEqual(relationUtils.generateSafeDOMId(a),'e-foo_Bar_relation_00000006___-'+relationUtils.generateHash(a))}),it('can generate safe relation ids with a parent id',()=>{const a='foo:Bar relation-00000006!@#';assert.notEqual(relationUtils.generateSafeDOMId(a,'topo1'),relationUtils.generateSafeDOMId(a,'topo2')),assert.strictEqual(relationUtils.generateSafeDOMId(a,'topo1'),'e-foo_Bar_relation_00000006___-'+relationUtils.generateHash(a+'topo1'))})}),describe('Utilities for handling relations',()=>{let a;beforeEach(()=>{const b=function(a){const b=a;return{set:function(a,c){b[a]=c},get:function(a){return b[a]}}};a=[{charm:b({provides:{website:{interface:'http',scope:'global'}},requires:{cache:{interface:'memcache',scope:'global'},db:{interface:'mysql',scope:'global'},nfs:{interface:'mount',scope:'global'}}}),name:'wordpress',service:{},type:'db'},{charm:b({provides:{db:{interface:'mysql',scope:'global'},"db-admin":{interface:'mysql-root',scope:'global'},"local-monitors":{interface:'local-monitors',scope:'container'},master:{interface:'mysql-oneway-replication',scope:'global'},monitors:{interface:'monitors',scope:'global'},munin:{interface:'munin-node',scope:'global'},"shared-db":{interface:'mysql-shared',scope:'global'}},requires:{ceph:{interface:'ceph-client',scope:'global'},ha:{interface:'hacluster',scope:'global'},slave:{interface:'mysql-oneway-replication',scope:'global'}}}),name:'mysql',service:{},type:'db'}]}),it('finds endpoint matches for relations',()=>{const b=relationUtils.findEndpointMatch(a),c={interface:'mysql',scope:'global',provides:a[1],requires:a[0],provideType:'db',requireType:'db'};assert.deepEqual(b,c)}),it('errors when no endpoint matches exist',()=>{a[1].charm.set('provides',{});const b=relationUtils.findEndpointMatch(a);assert.equal(b.error,'Specified relation is unavailable.')}),it('errors when multiple explicit endpoint matches exist',()=>{a[0].type=null,a[1].type=null,a[0].charm.set('requires',{db:{interface:'mysql',scope:'global'},"db-admin":{interface:'mysql',scope:'global'}}),a[1].charm.set('provides',{db:{interface:'mysql',scope:'global'},"db-admin":{interface:'mysql',scope:'global'}});const b=relationUtils.findEndpointMatch(a);assert.equal(b.error,'Ambiguous relationship is not allowed.')}),it('chooses the explicit relation over matching implicit',()=>{a[0].type=null,a[1].type=null,a[0].charm.set('requires',{db:{interface:'mysql',scope:'global'},"juju-info":{interface:'juju-info',scope:'container'}}),a[1].charm.set('provides',{db:{interface:'mysql',scope:'global'},"juju-info":{interface:'juju-info',scope:'container'}});const b=relationUtils.findEndpointMatch(a),c={interface:'mysql',scope:'global',provides:a[1],requires:a[0],provideType:'db',requireType:'db'};assert.deepEqual(b,c)})}),describe('relations visualization',function(){let b,c,d;beforeEach(()=>{b=new a.Database,c=new a.Service({id:'mysql',charm:'cs:mysql',unit_count:1,loaded:!0}),b.services.add(c),d=b.services.getById,b.services.getById=function(){return{get:function(){return'mediawiki'}}}}),afterEach(()=>{b.services.getById=d}),it('returns unique relations between applications',()=>{const d=new a.Service({id:'mediawiki-a',charm:'cs:mediawiki',unit_count:1,loaded:!0});b.services.add(d),b.relations.add({interface:'mysql',scope:'global',endpoints:[['mysql',{role:'server',name:'mydb'}],['mediawiki',{role:'client',name:'db'}]],id:'relation-0000000002'});const e=relationUtils.getRelationDataForService(b,c);assert.strictEqual(1,e.length);const f=relationUtils.getRelationDataForService(b,c,d);assert.strictEqual(0,f.length),b.relations.add({interface:'mysql',scope:'global',endpoints:[['mysql',{role:'server',name:'mydb'}],['mediawiki-a',{role:'client',name:'db'}]],id:'relation-0000000003'});const g=relationUtils.getRelationDataForService(b,c,d);assert.strictEqual(1,g.length)}),it('shows a juju-core rel from the perspective of a service',()=>{b.relations.add({interface:'mysql',scope:'global',endpoints:[['mysql',{role:'provider',name:'mydb'}],['mediawiki',{role:'requirer',name:'db'}]],id:'mediawiki:db mysql:mydb'});const a=relationUtils.getRelationDataForService(b,c);assert.strictEqual(1,a.length);const d=a[0];assert.strictEqual('mysql',d['interface'],'interface'),assert.strictEqual('global',d.scope,'scope'),assert.strictEqual('mediawiki:db mysql:mydb',d.id,'id'),assert.strictEqual(relationUtils.generateSafeDOMId('mediawiki:db mysql:mydb'),d.elementId,'elementId'),assert.strictEqual('mediawiki:db mysql:mydb',d.ident,'ident'),assert.strictEqual('mysql',d.near.service,'near service'),assert.strictEqual('provider',d.near.role,'near role'),assert.strictEqual('mydb',d.near.name,'near name'),assert.strictEqual('mediawiki',d.far.service,'far service'),assert.strictEqual('requirer',d.far.role,'far role'),assert.strictEqual('db',d.far.name,'far name')}),it('includes the service names',()=>{b.relations.add({interface:'mysql',scope:'global',endpoints:[['mysql',{role:'provider',name:'mydb'}],['mediawiki',{role:'requirer',name:'db'}]],id:'mediawiki:db mysql:mydb'});const a=relationUtils.getRelationDataForService(b,c)[0];assert.strictEqual(a.near.serviceName,'cs:mysql'),assert.strictEqual(a.far.serviceName,'mediawiki')}),it('does not fail if the far application has been removed',()=>{b.relations.add({interface:'mysql',scope:'global',endpoints:[['mysql',{role:'provider',name:'mydb'}],['mediawiki',{role:'requirer',name:'db'}]],id:'mediawiki:db mysql:mydb'}),b.services.getById=sinon.stub().returns(null);const a=relationUtils.getRelationDataForService(b,c)[0];assert.strictEqual(a.near.serviceName,'cs:mysql'),assert.isUndefined(a.far)})}),describe('DecoratedRelation and RelationCollection',()=>{let b,c,d,e;beforeEach(()=>{d={id:'source-id',model:{get:function(){}},modelId:function(){return'source-id'},_units:[],units:{toArray:()=>d._units}},e={id:'target-id',model:{get:function(){}},modelId:function(){return'target-id'},_units:[],units:{toArray:()=>e._units}},c=new a.Relation({endpoints:[['source-id',{name:'endpoint-1'}],['target-id',{name:'endpoint-2'}]]}),b={agent_state:void 0,agent_state_data:{hook:void 0}}}),it('mirrors the relation\'s properties',()=>{c.set('foo','bar');const a=relationUtils.DecoratedRelation(c,d,e);assert.nestedProperty(a,'foo'),assert.equal(a.foo,'bar')}),it('exposes the source and target as attributes',()=>{const a=relationUtils.DecoratedRelation(c,d,e);assert.equal(a.source,d),assert.equal(a.target,e)}),it('generates an ID that includes source and target IDs',()=>{const a=relationUtils.DecoratedRelation(c,d,e);assert.match(a.compositeId,new RegExp(d.modelId())),assert.match(a.compositeId,new RegExp(e.modelId()))}),it('includes endpoint names in its ID, if they exist',()=>{const a=relationUtils.DecoratedRelation(c,d,e);assert.match(a.compositeId,/endpoint-1/),assert.match(a.compositeId,/endpoint-2/)}),it('exposes the fact that a relation is a subordinate',()=>{c.set('scope','container'),d.model.get=function(){return!0};const a=relationUtils.DecoratedRelation(c,d,e);assert.isTrue(a.isSubordinate)}),it('exposes the fact that a relation is not a subordinate',()=>{c.set('scope','not-container'),d.model.get=function(){return!1};let a=relationUtils.DecoratedRelation(c,d,e);assert.isFalse(a.isSubordinate),d.model.get=function(){return!0},a=relationUtils.DecoratedRelation(c,d,e),assert.isFalse(a.isSubordinate),d.model.get=function(){return!1},e.model.get=function(){return!1},c.set('scope','container'),a=relationUtils.DecoratedRelation(c,d,e),assert.isFalse(a.isSubordinate)}),it('can tell when a relation is in error',()=>{d._units=[Object.assign({},b)],e._units=[Object.assign({},b)];const a=relationUtils.DecoratedRelation(c,d,e);assert.isFalse(a.sourceHasError()),assert.isFalse(a.targetHasError()),assert.isFalse(a.hasRelationError()),d._units[0].agent_state='error',d._units[0].agent_state_data.hook='endpoint-1-relation',assert.isTrue(a.sourceHasError()),assert.isFalse(a.targetHasError()),assert.isTrue(a.hasRelationError()),d._units[0].agent_state='error',d._units[0].agent_state_data=null,d._units[0].agent_state_info='hook failed: "endpoint-1-relation"',assert.isTrue(a.sourceHasError()),assert.isFalse(a.targetHasError()),assert.isTrue(a.hasRelationError()),d._units[0].agent_state='error',d._units[0].agent_state_data=null,d._units[0].agent_state_info=null,assert.isFalse(a.sourceHasError()),assert.isFalse(a.targetHasError()),assert.isFalse(a.hasRelationError())}),it('can store relations in collections',()=>{const a=[relationUtils.DecoratedRelation(c,d,e),relationUtils.DecoratedRelation(c,d,e),relationUtils.DecoratedRelation(c,d,{model:{get:function(){}},modelId:function(){return'third-id'}})],b=relationUtils.toRelationCollections(a);assert.equal(b.length,2),assert.equal(b[0].relations.length,2),assert.equal(b[0].aggregatedStatus,'healthy'),assert.isFalse(b[0].isSubordinate),assert.equal(b[0].id,b[0].relations[0].id),assert.equal(b[0].compositeId,b[0].relations[0].id)}),it('can aggregate relation statuses',()=>{const a=Object.assign({},d);a.modelId='third-id',a._units=[Object.assign({},b)],a._units[0].agent_state='error',a._units[0].agent_state_data.hook='endpoint-1-relation',a.units={toArray:function(){return a._units}};const f=[relationUtils.DecoratedRelation(c,d,e),relationUtils.DecoratedRelation(c,d,e),relationUtils.DecoratedRelation(c,d,a)],g=relationUtils.toRelationCollections(f);assert.equal(g[0].aggregatedStatus,'healthy'),assert.equal(g[1].aggregatedStatus,'error'),g[0].relations[0].isSubordinate=!0,assert.equal(g[0].aggregatedStatus,'healthy'),g[0].relations[0].deleted=!0,assert.equal(g[0].aggregatedStatus,'pending-healthy'),g[0].relations[1].isSubordinate=!0,assert.equal(g[0].aggregatedStatus,'subordinate'),g[1].relations[0].isSubordinate=!0,assert.equal(g[1].aggregatedStatus,'error'),g[1].relations[0].deleted=!0,assert.equal(g[1].aggregatedStatus,'pending-error'),g[1].relations[0].pending=!0,assert.equal(g[1].aggregatedStatus,'pending')})}),describe('isSubordinateRelation',()=>{it('can tell if a relation is a subordinate',()=>{assert.isTrue(relationUtils.isSubordinateRelation({scope:'container'}))}),it('can tell if a relation is not a subordinate',()=>{assert.isFalse(relationUtils.isSubordinateRelation({scope:'not-a-container'}))})}),describe('createRelation',()=>{it('properly creates a relation',()=>{const a='pending-19984570$:db23212464$:db',b=sinon.stub();b.withArgs('requires').onFirstCall().returns({db:{interface:'db',scope:'global'}}),b.withArgs('requires').onSecondCall().returns({misc:{interface:'misc',scope:'global'}}),b.withArgs('provides').returns({db:{interface:'db',scope:'global'}});const c={charms:{getById:sinon.stub().returns({get:b}),size:sinon.stub()},relations:{add:sinon.stub(),remove:sinon.stub(),create:sinon.stub(),getById:sinon.stub().returns(a)},services:{getById:sinon.stub().returns({get:sinon.stub()})}},d={add_relation:sinon.stub()},e=[['19984570$',{name:'db',role:'client'}],['23212464$',{name:'db',role:'server'}]];relationUtils.createRelation(c,d,e,sinon.stub()),assert.equal(c.relations.add.callCount,1),assert.deepEqual(c.relations.add.lastCall.args[0],{relation_id:a,interface:'db',endpoints:e,pending:!0,scope:'global',display_name:'pending'}),assert.equal(d.add_relation.callCount,1),assert.deepEqual(d.add_relation.lastCall.args[0],e[0]),assert.deepEqual(d.add_relation.lastCall.args[1],e[1]),d.add_relation.lastCall.args[2]({result:{id:'foo',interface:'bar',scope:'global'}}),assert.equal(c.relations.remove.callCount,1),assert.equal(c.relations.remove.lastCall.args[0],a),assert.equal(c.relations.create.callCount,1),assert.deepEqual(c.relations.create.lastCall.args[0],{relation_id:'foo',type:'bar',endpoints:e,pending:!1,scope:'global'})}),it('relates a subordinate with a matching series',()=>{const a='pending-19984570$:db23212464$:db',b=sinon.stub();b.withArgs('requires').onFirstCall().returns({db:{interface:'db',scope:'global'}}),b.withArgs('requires').onSecondCall().returns({misc:{interface:'misc',scope:'global'}}),b.withArgs('provides').returns({db:{interface:'db',scope:'global'}});const c=sinon.stub(),d=sinon.stub();d.withArgs('subordinate').onFirstCall().returns(!0),d.withArgs('subordinate').onSecondCall().returns(!1),d.withArgs('series').returns('xenial');const e={charms:{getById:sinon.stub().returns({get:b}),size:sinon.stub()},relations:{add:sinon.stub(),remove:sinon.stub(),create:sinon.stub(),getById:sinon.stub().returns(a)},services:{getById:sinon.stub().returns({get:d,set:c})}},f={add_relation:sinon.stub()},g=[['19984570$',{name:'db',role:'client'}],['23212464$',{name:'db',role:'server'}]];relationUtils.createRelation(e,f,g,sinon.stub()),assert.equal(e.relations.add.callCount,1),assert.deepEqual(e.relations.add.lastCall.args[0],{relation_id:a,interface:'db',endpoints:g,pending:!0,scope:'global',display_name:'pending'}),assert.equal(f.add_relation.callCount,1),assert.deepEqual(f.add_relation.lastCall.args[0],g[0]),assert.deepEqual(f.add_relation.lastCall.args[1],g[1]),f.add_relation.lastCall.args[2]({result:{id:'foo',interface:'bar',scope:'global'}}),assert.equal(e.relations.remove.callCount,1),assert.equal(e.relations.remove.lastCall.args[0],a),assert.equal(e.relations.create.callCount,1),assert.deepEqual(e.relations.create.lastCall.args[0],{relation_id:'foo',type:'bar',endpoints:g,pending:!1,scope:'global'}),assert.equal(c.callCount,0)}),it('relates multi-series subordinate with non-matching series',()=>{const a='pending-19984570$:db23212464$:db',b=sinon.stub();b.withArgs('requires').onFirstCall().returns({db:{interface:'db',scope:'global'}}),b.withArgs('requires').onSecondCall().returns({misc:{interface:'misc',scope:'global'}}),b.withArgs('provides').returns({db:{interface:'db',scope:'container'}});const c=sinon.stub(),d=sinon.stub();d.withArgs('subordinate').onFirstCall().returns(!0),d.withArgs('subordinate').onSecondCall().returns(!1),d.withArgs('series').onFirstCall().returns('trusty'),d.withArgs('series').onSecondCall().returns('xenial');const e={charms:{getById:sinon.stub().returns({get:b}),size:sinon.stub()},relations:{add:sinon.stub(),remove:sinon.stub(),create:sinon.stub(),getById:sinon.stub().returns(a),get_relations_for_service:sinon.stub().returns([])},services:{getById:sinon.stub().returns({get:d,set:c})}},f={add_relation:sinon.stub()},g=[['19984570$',{name:'db',role:'client'}],['23212464$',{name:'db',role:'server'}]];relationUtils.createRelation(e,f,g,sinon.stub()),assert.equal(e.relations.add.callCount,1),assert.deepEqual(e.relations.add.lastCall.args[0],{relation_id:a,interface:'db',endpoints:g,pending:!0,scope:'container',display_name:'pending'}),assert.equal(f.add_relation.callCount,1),assert.deepEqual(f.add_relation.lastCall.args[0],g[0]),assert.deepEqual(f.add_relation.lastCall.args[1],g[1]),f.add_relation.lastCall.args[2]({result:{id:'foo',interface:'bar',scope:'global'}}),assert.equal(e.relations.remove.callCount,1),assert.equal(e.relations.remove.lastCall.args[0],a),assert.equal(e.relations.create.callCount,1),assert.deepEqual(e.relations.create.lastCall.args[0],{relation_id:'foo',type:'bar',endpoints:g,pending:!1,scope:'global'}),assert.equal(c.callCount,1),assert.equal(c.args[0][0],'series'),assert.equal(c.args[0][1],'trusty')})}),describe('getAvailableEndpoints',()=>{function a(a){const b={};b[a.applicationToId]=JSON.parse(a.getEndpoints);const c=sinon.stub().returns(b),d=a.applicationFrom||{};return relationUtils.getAvailableEndpoints('endpointsController','db',c,d,{get:function(){return a.applicationToId}},JSON.parse(a.getRelationDataForService))}describe('works with...',()=>{it('two services, one possible endpoint',()=>{const b='[[{"service":"8784924$","name":"db","type":"mysql"},{"service":"38546607$","name":"db","type":"mysql"}]]',c=a({applicationToId:'38546607$',getEndpoints:b,getRelationDataForService:'[]'},_this);assert.deepEqual(c,JSON.parse(b))}),it('two services, one full endpoint',()=>{const b=a({applicationToId:'38546607$',getEndpoints:'[[{"service":"8784924$","name":"db","type":"mysql"},{"service":"38546607$","name":"db","type":"mysql"}]]',getRelationDataForService:'[{"interface":"db","initialized":true,"destroyed":false,"clientId":"relation_10","id":"pending-8784924$:db38546607$:db","relation_id":"pending-8784924$:db38546607$:db","endpoints":[["8784924$",{"name":"db","role":"client"}],["38546607$",{"name":"db","role":"server"}]],"pending":true,"scope":"global","display_name":"pending","near":{"service":"38546607$","serviceName":"wordpress","role":"server","name":"db"},"far":{"service":"8784924$","serviceName":"mariadb","role":"client","name":"db"},"ident":"pending-8784924$:db38546607$:db","elementId":"e-pending_8784924__db38546607__db-1455252509"}]'},_this);assert.deepEqual(b,[])}),it('two services, two possible and empty endpoints',()=>{const b='[[{"service":"1485178$","name":"master","type":"mysql-oneway-replication"},{"service":"81820288$","name":"slave","type":"mysql-oneway-replication"}],[{"service":"1485178$","name":"slave","type":"mysql-oneway-replication"},{"service":"81820288$","name":"master","type":"mysql-oneway-replication"}]]',c=a({applicationToId:'1485178$',getEndpoints:b,getRelationDataForService:'[]'},_this);assert.deepEqual(c,JSON.parse(b))}),it('two services, one possible and one full endpoint',()=>{const b=a({applicationToId:'12648410$',getEndpoints:'[[{"service":"96799599$","name":"master","type":"mysql-oneway-replication"},{"service":"12648410$","name":"slave","type":"mysql-oneway-replication"}],[{"service":"96799599$","name":"slave","type":"mysql-oneway-replication"},{"service":"12648410$","name":"master","type":"mysql-oneway-replication"}]]',getRelationDataForService:'[{"initialized":true,"destroyed":false,"clientId":"relation_72","id":"pending-96799599$12648410$slavemaster","relation_id":"pending-96799599$12648410$slavemaster","endpoints":[["96799599$",{"name":"slave","role":"server"}],["12648410$",{"name":"master","role":"client"}]],"pending":true,"scope":"global","display_name":"pending","near":{"service":"12648410$","serviceName":"mysql","role":"client","name":"master"},"far":{"service":"96799599$","serviceName":"mysql-a","role":"server","name":"slave"},"ident":"pending-96799599$12648410$slavemaster","elementId":"e-pending_96799599_12648410_slavemaster-1611657570"}]'},_this);assert.deepEqual(b,JSON.parse('[[{"service":"96799599$","name":"master","type":"mysql-oneway-replication"},{"service":"12648410$","name":"slave","type":"mysql-oneway-replication"}]]'))}),it('two services, no possible and two full endpoints',()=>{const b=a({applicationToId:'93057667$',getEndpoints:'[[{"service":"24412010$","name":"master","type":"mysql-oneway-replication"},{"service":"93057667$","name":"slave","type":"mysql-oneway-replication"}],[{"service":"24412010$","name":"slave","type":"mysql-oneway-replication"},{"service":"93057667$","name":"master","type":"mysql-oneway-replication"}]]',getRelationDataForService:'[{"interface":"master","initialized":true,"destroyed":false,"clientId":"relation_72","id":"pending-24412010$:master93057667$:slave","relation_id":"pending-24412010$:master93057667$:slave","endpoints":[["24412010$",{"name":"master","role":"client"}],["93057667$",{"name":"slave","role":"server"}]],"pending":true,"scope":"global","display_name":"pending","near":{"service":"93057667$","serviceName":"mysql","role":"server","name":"slave"},"far":{"service":"24412010$","serviceName":"mysql-a","role":"client","name":"master"},"ident":"pending-24412010$:master93057667$:slave","elementId":"e-pending_24412010__master93057667__slave-278287960"},{"interface":"slave","initialized":true,"destroyed":false,"clientId":"relation_73","id":"pending-24412010$:slave93057667$:master","relation_id":"pending-24412010$:slave93057667$:master","endpoints":[["24412010$",{"name":"slave","role":"client"}],["93057667$",{"name":"master","role":"server"}]],"pending":true,"scope":"global","display_name":"pending","near":{"service":"93057667$","serviceName":"mysql","role":"server","name":"master"},"far":{"service":"24412010$","serviceName":"mysql-a","role":"client","name":"slave"},"ident":"pending-24412010$:slave93057667$:master","elementId":"e-pending_24412010__slave93057667__master-1283641382"}]'},_this);assert.deepEqual(b,[])})})}),describe('getRelatableApplications',()=>{it('properly returns relatable applications',()=>{const a='service1';assert.deepEqual([a],relationUtils.getRelatableApplications({services:{getById:function(){return a}}},{"7117087$":[[{service:'2003212$',name:'db',type:'mysql'},{service:'7117087$',name:'db',type:'mysql'}]]}))})}),describe('destroyRelations',()=>{it('can destroy a list of relations',()=>{const a={relations:{getById:sinon.stub().returns({get:sinon.stub().returns(['endpoint1','endpoint2'])})}},b={remove_relation:sinon.stub()},c=sinon.stub();relationUtils.destroyRelations(a,b,['relation1'],c),assert.equal(b.remove_relation.callCount,1);const d=b.remove_relation.args[0];assert.equal(d[0],'endpoint1'),assert.equal(d[1],'endpoint2'),assert.equal(d[2],c)})})});